﻿var sendData = false;
var canSave = true;

$(document).ready(function () {
    $(document).click(function () {
        saveNote();
    });

    $(".notes .left-box").sortable({
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-id' });

            $.post(
                RQ_URL + "/Notes/SortNotes",
                $.param(
                    { sortedIds: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { })
                .done(function () { });
        }
    });

    $("body").on("click", ".note",function (e) {
        e.preventDefault();
        saveNote();
        var id = $(this).data("id");
        $(".note").removeClass("selected");
        $(this).addClass("selected");
        getNote(id);
    });

    $("body").on("click", ".body a", function (e) {
        window.location.href = $(this).prop("href");
    });

    $("body").on("click", ".remove-note", function (e) {
        e.preventDefault();
        sendData = false;
        deleteDialog($("#NoteId").val());
    });

    $("body").on("click", ".new-note", function (e) {
        e.preventDefault();
        $(".left-box").show();
        $("#EmptyMessage").hide();
        sendData = false;
        newNote();
    });
});

function getNote(id) {
    tinymce.remove("#NoteBodyText");
    $("#NoteBody").html("<div class='loading-32'></div>");
    $("#NoteBody").load(RQ_URL + "/Notes/GetNote/" + id);
}

function newNote() {
    $(".note").removeClass("selected");
    tinymce.remove("#NoteBodyText");
    $("#NoteBody").html("<div class='loading-32'></div>");
    $.ajaxSetup({
        // Disable caching of AJAX responses
        cache: false
    });
    $("#NoteBody").load(RQ_URL + "/Notes/NewNote", function () {
        sendData = true;
        saveNote();
    });
}

function exportPdf() {
    saveNote(RQ_URL + "/Notes/Export/");
}

function saveNote(url) {
    if (sendData && canSave) {
        canSave = false;
        $(".saving").show();
        var ntId = $("#NoteId").val();
        $.post(
           RQ_URL + '/Notes/Save',
           {
               Id: ntId,
               New: $("#NoteNew").val(),
               Text: $("#NoteBodyText").html(),
               IsPrivate: $("#NotePrivate").is(":checked"),
               Color: $("#NoteBody .color").val()
           },
           function (data) {
               $(".saving").fadeOut(1500);
               canSave = true
               if (url == "" || url == undefined) {
                   if ($("#NoteNew").val() == "True") {
                       $(".notes .left-box").prepend(data);
                       $("#NoteId").val($(data).filter(".note").data("id"));
                       $('.notes .left-box .note[data-id="' + ntId + '"]').addClass("selected");
                       $("#NoteNew").val("False");
                   }
                   else {
                       $('.notes .left-box .note[data-id="' + ntId + '"]').html($(data).filter('.note').html());
                   }
               }
               else {
                   window.location.href = url + $("#NoteId").val();
               }
           },
           "html")
.error(function (error) {
    alert(error.responseText);
    //tady nevyhazuju erorr není to podstatné ukládá se to často a ty chyby
})
.success(function () { });
    }
}